diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
index b7a2a0605..535d28847 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
@@ -37,15 +37,8 @@ public abstract class TileEntity implements ICarriable
 
     public void setChanged()
     {
-        if(worldObj != null)
-        {
-            int id = getBlockId();
-            if (id != 0 && Blocks.getBlock(id).isSignalSource()) {
-                for (Side s : Side.sides){
-                    worldObj.notifyBlocksOfNeighborChange(tilePos.x + s.getOffsetX(), tilePos.y + s.getOffsetY(), tilePos.z + s.getOffsetZ(), getBlockId());
-                }
-            }
-            worldObj.updateTileEntityChunkAndSendToPlayer(tilePos.x, tilePos.y, tilePos.z, this);
+        if(worldObj != null) {
+            worldObj.updateTileEntityChunkAndSendToPlayer(tilePos, this);
         }
     }
     
@@ -143,9 +136,9 @@ public abstract class TileEntity implements ICarriable
     @Override
     public boolean tryPlace(World world, Entity holder, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         CarriedBlock carriedBlock = this.carriedBlock;
-        tilePos.x = blockX + side.getOffsetX();
-        tilePos.y = blockY + side.getOffsetY();
-        tilePos.z = blockZ + side.getOffsetZ();
+        tilePos.x = blockX + side.offsetX();
+        tilePos.y = blockY + side.offsetY();
+        tilePos.z = blockZ + side.offsetZ();
 
         Block<?> currentBlock = world.getBlock(tilePos.x, tilePos.y, tilePos.z);
         if (currentBlock != null && !currentBlock.hasTag(BlockTags.PLACE_OVERWRITES)) return false;
@@ -159,12 +152,8 @@ public abstract class TileEntity implements ICarriable
         if (b != null && holder instanceof Mob) {
             b.onBlockPlacedByMob(world, tilePos.x, tilePos.y, tilePos.z, side, (Mob) holder, xPlaced, yPlaced);
         }
-        world.notifyBlockChange(tilePos.x, tilePos.y, tilePos.z, carriedBlock.blockId);
-        if (carriedBlock.blockId != 0 && Blocks.getBlock(carriedBlock.blockId).isSignalSource()) {
-            for (Side s : Side.sides){
-                world.notifyBlocksOfNeighborChange(tilePos.x + s.getOffsetX(), tilePos.y + s.getOffsetY(), tilePos.z + s.getOffsetZ(), getBlockId());
-            }
-        }
+        final boolean isSignal = Blocks.getBlock(carriedBlock.blockId).isSignalSource();
+        world.notifyBlocksInRadiusOfNeighborChange((isSignal) ? 2 : 1, tilePos, currentBlock);
         return true;
     }
 
@@ -193,13 +182,8 @@ public abstract class TileEntity implements ICarriable
         int currentMeta = world.getBlockMetadata(tilePos.x, tilePos.y, tilePos.z);
         world.removeBlockTileEntity(tilePos.x, tilePos.y, tilePos.z);
         world.setBlockRaw(tilePos.x, tilePos.y, tilePos.z, 0);
-        world.notifyBlockChange(tilePos.x, tilePos.y, tilePos.z, 0);
-        int id = getBlockId();
-        if (currentBlock.isSignalSource()) {
-            for (Side s : Side.sides){
-                worldObj.notifyBlocksOfNeighborChange(tilePos.x + s.getOffsetX(), tilePos.y + s.getOffsetY(), tilePos.z + s.getOffsetZ(), getBlockId());
-            }
-        }
+        final boolean isSignal = this.getBlock().isSignalSource();
+        world.notifyBlocksInRadiusOfNeighborChange((isSignal) ? 2 : 1, tilePos, currentBlock);
         this.worldObj = null;
         this.carriedBlock = getCarriedEntry(world, holder, currentBlock, currentMeta);
         return carriedBlock;
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
index 67f4f074d..0dc111172 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
@@ -4,7 +4,6 @@ import java.util.*;
 
 import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
 import it.unimi.dsi.fastutil.objects.Object2IntMap;
-import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
@@ -33,7 +32,8 @@ public class TileEntityBasket extends TileEntity implements ICarrySource {
         int currentNumInside = calcNumUnitsInside();
         if (currentNumInside != numUnitsInside && worldObj != null) {
             this.numUnitsInside = currentNumInside;
-            worldObj.notifyBlockChange(tilePos.x, tilePos.y, tilePos.z, worldObj.getBlockId(tilePos.x, tilePos.y, tilePos.z));
+            worldObj.markBlockNeedsUpdate(tilePos);
+            worldObj.notifyBlocksInRadiusOfNeighborChange(2, tilePos, getBlock());
             setChanged();
         }
     }
@@ -109,7 +109,6 @@ public class TileEntityBasket extends TileEntity implements ICarrySource {
         }
 
         updateNumUnits();
-        world.notifyBlockChange(this.tilePos.x, this.tilePos.y, this.tilePos.z, Blocks.BASKET.id());
     }
 
     @Override
@@ -168,12 +167,7 @@ public class TileEntityBasket extends TileEntity implements ICarrySource {
             }
         }
 
-        if (shouldUpdate) {
-            if (this.worldObj != null) {
-                this.worldObj.notifyBlockChange(this.tilePos.x, this.tilePos.y, this.tilePos.z, Blocks.BASKET.id());
-            }
-            updateNumUnits();
-        }
+        if (shouldUpdate) updateNumUnits();
     }
 
     private boolean importItemStack(final ItemStack stack) {
@@ -232,7 +226,6 @@ public class TileEntityBasket extends TileEntity implements ICarrySource {
 
         this.contents.clear();
 
-        world.notifyBlockChange(x, y, z, Blocks.BASKET.id());
         updateNumUnits();
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
index 6137d822f..c43ced3f4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
@@ -90,6 +90,7 @@ public class TileEntityDispatcher {
         addMapping(TileEntityMesh.class, NamespaceID.fromPool("minecraft", "mesh"));
         addMapping(TileEntityMeshGold.class, NamespaceID.fromPool("minecraft", "mesh_gold"));
         addMapping(TileEntityStatue.class, NamespaceID.fromPool("minecraft", "statue_stone"));
+        addMapping(TileEntityTimer.class, NamespaceID.fromPool("minecraft", "timer"));
     }
 
     @Deprecated
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMesh.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMesh.java
index 73fac3ed1..6f08d6bd5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMesh.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMesh.java
@@ -72,11 +72,11 @@ public class TileEntityMesh extends TileEntity {
             if (entity instanceof EntityItem item && entity.isInWater())
             {
                 if(item.meshSiphoning == null && item.siphonDirection == Direction.NONE){
-                    item.siphonDirection = direction.getOpposite();
+                    item.siphonDirection = direction.opposite();
                     item.meshSiphoning = this;
                 }
 
-                if(direction.getOpposite().equals(item.siphonDirection) && item.meshSiphoning == this) {
+                if(direction.opposite().equals(item.siphonDirection) && item.meshSiphoning == this) {
 
                     if (!this.worldObj.isClientSide) {
                         Player player = entity.world.getClosestPlayer(tilePos.x, tilePos.y, tilePos.z, 12);
@@ -148,14 +148,14 @@ public class TileEntityMesh extends TileEntity {
         double centerZ = tilePos.z + 0.5;
 
         // move the center to the edge of the block face
-        centerX += facing.getOffsetX() * 0.5;
-        centerY += facing.getOffsetY() * 0.5;
-        centerZ += facing.getOffsetZ() * 0.5;
+        centerX += facing.offsetX() * 0.5;
+        centerY += facing.offsetY() * 0.5;
+        centerZ += facing.offsetZ() * 0.5;
 
         // move height distance further in the facing direction
-        double farX = centerX + (facing.getOffsetX() * siphonHeight);
-        double farY = centerY + (facing.getOffsetY() * siphonHeight);
-        double farZ = centerZ + (facing.getOffsetZ() * siphonHeight);
+        double farX = centerX + (facing.offsetX() * siphonHeight);
+        double farY = centerY + (facing.offsetY() * siphonHeight);
+        double farZ = centerZ + (facing.offsetZ() * siphonHeight);
 
 
         // need a half width since in middle of block
@@ -171,15 +171,15 @@ public class TileEntityMesh extends TileEntity {
         double maxZ = Math.max(centerZ, farZ);
 
         // expand based on the axis we are NOT facing
-        if (facing.getAxis() != Axis.X) {
+        if (facing.axis() != Axis.X) {
             minX -= hw;
             maxX += hw;
         }
-        if (facing.getAxis() != Axis.Y) {
+        if (facing.axis() != Axis.Y) {
             minY -= hw;
             maxY += hw;
         }
-        if (facing.getAxis() != Axis.Z) {
+        if (facing.axis() != Axis.Z) {
             minZ -= hw;
             maxZ += hw;
         }
@@ -227,10 +227,10 @@ public class TileEntityMesh extends TileEntity {
 
             //axis check to make sure the swirl behaves correctly depending on facing direction
             double sX = 0, sY = 0, sZ = 0;
-            if (direction.getAxis() == Axis.Y) {
+            if (direction.axis() == Axis.Y) {
                 sX = -diffZ;
                 sZ = diffX;
-            } else if (direction.getAxis() == Axis.Z) {
+            } else if (direction.axis() == Axis.Z) {
                 sX = -diffY;
                 sY = diffX;
             } else {
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
index 0ad61f978..557c0796f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
@@ -105,10 +105,10 @@ public class TileEntityMeshGold extends TileEntityMesh {
             if (entity instanceof EntityItem item && entity.isInWater())
             {
                 if(item.meshSiphoning == null && item.siphonDirection == Direction.NONE){
-                    item.siphonDirection = direction.getOpposite();
+                    item.siphonDirection = direction.opposite();
                     item.meshSiphoning = this;
                 }
-                if(direction.getOpposite().equals(item.siphonDirection) && item.meshSiphoning == this) {
+                if(direction.opposite() == item.siphonDirection && item.meshSiphoning == this) {
                     if (item.item.getItem() == this.filterItem.getItem() && item.item.getMetadata() == this.filterItem.getMetadata()) {
 
                         Player player = entity.world.getClosestPlayer(tilePos.x, tilePos.y, tilePos.z, 12);
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
index b22191f02..81624ba86 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
@@ -25,15 +25,15 @@ public class TileEntitySensor extends TileEntity {
         }
 
         int range = 4;
-        int blockInFront = world.getBlockId(MathHelper.round(x + facing.getOffsetX()), MathHelper.round(y + facing.getOffsetY()), MathHelper.round(z + facing.getOffsetZ()));
+        int blockInFront = world.getBlockId(MathHelper.round(x + facing.offsetX()), MathHelper.round(y + facing.offsetY()), MathHelper.round(z + facing.offsetZ()));
         if (Blocks.hasTag(blockInFront, BlockTags.EXTENDS_MOTION_SENSOR_RANGE)) {
             range = 8;
         }
 
         for (int i = 1; i <= range; i++) {
-            int x1 = MathHelper.round(x + facing.getOffsetX() * i);
-            int y1 = MathHelper.round(y + facing.getOffsetY() * i);
-            int z1 = MathHelper.round(z + facing.getOffsetZ() * i);
+            int x1 = MathHelper.round(x + facing.offsetX() * i);
+            int y1 = MathHelper.round(y + facing.offsetY() * i);
+            int z1 = MathHelper.round(z + facing.offsetZ() * i);
             int id = world.getBlockId(x1, y1, z1);
             if (Blocks.solid[id] && !Blocks.hasTag(id, BlockTags.EXTENDS_MOTION_SENSOR_RANGE)) {
                 return i - 1;
@@ -44,13 +44,13 @@ public class TileEntitySensor extends TileEntity {
     }
 
     private @NotNull AABBdc getDetectionBox(double x, double y, double z, @NotNull Direction facing, int range) {
-        double x1 = x + facing.getOffsetX();
-        double y1 = y + facing.getOffsetY();
-        double z1 = z + facing.getOffsetZ();
+        double x1 = x + facing.offsetX();
+        double y1 = y + facing.offsetY();
+        double z1 = z + facing.offsetZ();
 
-        double x2 = x + facing.getOffsetX() * range;
-        double y2 = y + facing.getOffsetY() * range;
-        double z2 = z + facing.getOffsetZ() * range;
+        double x2 = x + facing.offsetX() * range;
+        double y2 = y + facing.offsetY() * range;
+        double z2 = z + facing.offsetZ() * range;
 
         double minX = Math.min(x1, x2);
         double minY = Math.min(y1, y2);
@@ -154,7 +154,9 @@ public class TileEntitySensor extends TileEntity {
             final var block = (active)
                 ? Blocks.MOTION_SENSOR_ACTIVE
                 : Blocks.MOTION_SENSOR_IDLE;
-            world.setBlockTypeDataNotify(this.tilePos, block, meta);
+            world.setBlockTypeData(this.tilePos, block, meta);
+            world.markBlockNeedsUpdate(this.tilePos);
+            world.notifyBlocksInRadiusOfNeighborChange(2, this.tilePos, block);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTimer.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTimer.java
new file mode 100644
index 000000000..6c5434e25
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTimer.java
@@ -0,0 +1,56 @@
+package net.minecraft.core.block.entity;
+
+import com.mojang.nbt.tags.CompoundTag;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicTimer;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.Axis;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.pos.TilePos;
+import org.jetbrains.annotations.NotNull;
+
+public class TileEntityTimer extends TileEntity {
+    // This has got to be one of the simplest tile entities of all time.
+
+    @Override
+    public void readAdditionalData(@NotNull CompoundTag compoundTag) {
+        // Do nothing
+    }
+
+    @Override
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag) {
+        // Do nothing
+    }
+
+    @Override
+    public void tick() {
+        if (this.worldObj == null || this.worldObj.isClientSide) {
+            return;
+        }
+
+        Block<?> block = this.worldObj.getBlockType(this.tilePos);
+        if (block != Blocks.TIMER) {
+            return;
+        }
+
+        final int currentMeta = this.worldObj.getBlockData(this.tilePos);
+        final int currentAxis = currentMeta & BlockLogicTimer.MASK_AXIS;
+        final int currentDelay = currentMeta & BlockLogicTimer.MASK_TICK_DELAY;
+
+        final long currentTick = this.worldObj.getTotalWorldTime();
+        final long interval = BlockLogicTimer.tickDelayMap[currentDelay >> 2];
+        if (currentTick % interval == 0) {
+            final int newOutput =
+                ((currentTick % (interval * 2) == 0) ? BlockLogicTimer.OUTPUT_A : BlockLogicTimer.OUTPUT_B);
+            final int newMeta = currentDelay | newOutput | currentAxis;
+
+            this.worldObj.setBlockData(this.tilePos, newMeta);
+            this.worldObj.markBlockNeedsUpdate(this.tilePos);
+
+            final Side side = BlockLogicTimer.getSideFromMeta(currentMeta);
+
+            this.worldObj.notifyBlocksInCapsuleOfNeighborChange(side, this.tilePos, Blocks.TIMER);
+            this.worldObj.notifyBlocksInCapsuleOfNeighborChange(side.opposite(), this.tilePos, Blocks.TIMER);
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
index 21f4555e3..691d2cbe5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
@@ -312,10 +312,12 @@ public class TileEntityTrommel extends TileEntity
         if(itemResult!=null)
         {
         	// Check if chest is adjacent
-
-        	int adjacentId = this.worldObj != null ? this.worldObj.getBlockId(this.tilePos.x + direction.getOffsetX(), this.tilePos.y + direction.getOffsetY(), this.tilePos.z + direction.getOffsetZ()) : 0;
+            final var queryPos = new TilePos();
+        	int adjacentId = this.worldObj != null 
+                ? this.worldObj.getBlockType(queryPos.set(this.tilePos).add(direction)).id() 
+                : 0;
         	if (this.worldObj != null && Block.hasLogicClass(Blocks.blocksList[adjacentId], BlockLogicChest.class)) {
-                Container chest = BlockLogicChest.getInventory(this.worldObj, new TilePos(this.tilePos.x + direction.getOffsetX(), this.tilePos.y + direction.getOffsetY(), this.tilePos.z + direction.getOffsetZ()));
+                Container chest = BlockLogicChest.getInventory(this.worldObj, queryPos);
 
                 for (int i = 0; i < chest.getContainerSize(); i++)
                 {
@@ -346,12 +348,12 @@ public class TileEntityTrommel extends TileEntity
             if(itemResult.stackSize > 0) {
                 if (this.worldObj != null) {
                     if (this.worldObj.isAirBlock(new TilePos(this.tilePos.x, this.tilePos.y, this.tilePos.z).add(direction))) {
-                        EntityItem droppedItem = new EntityItem(this.worldObj, this.tilePos.x + 0.5 + direction.getOffsetX() * 0.5, this.tilePos.y + 0.5 + direction.getOffsetY() * 0.5, this.tilePos.z + 0.5 + direction.getOffsetZ() * 0.5, itemResult);
+                        EntityItem droppedItem = new EntityItem(this.worldObj, this.tilePos.x + 0.5 + direction.offsetX() * 0.5, this.tilePos.y + 0.5 + direction.offsetY() * 0.5, this.tilePos.z + 0.5 + direction.offsetZ() * 0.5, itemResult);
                         droppedItem.pickupDelay = 10;
-                        droppedItem.fling(direction.getOffsetX() * 0.3125, direction.getOffsetY() * 0.3125, direction.getOffsetZ() * 0.3125, 1);
+                        droppedItem.fling(direction.offsetX() * 0.3125, direction.offsetY() * 0.3125, direction.offsetZ() * 0.3125, 1);
                         this.worldObj.entityJoinedWorld(droppedItem);
                     } else {
-                        this.worldObj.dropItem(this.tilePos.x, this.tilePos.y, this.tilePos.z, itemResult);
+                        this.worldObj.dropItem(this.tilePos, itemResult);
                     }
                 } else if (this.carriedBlock != null) {
                     this.carriedBlock.world.dropItem(MathHelper.floor(this.carriedBlock.holder.x), MathHelper.floor(this.carriedBlock.holder.y), MathHelper.floor(this.carriedBlock.holder.z), itemResult);
@@ -371,8 +373,8 @@ public class TileEntityTrommel extends TileEntity
             mobSlime.zd = (float) this.random.nextGaussian() * f3;
             if (this.worldObj != null) {
                 if (this.worldObj.isAirBlock(new TilePos(this.tilePos.x, this.tilePos.y, this.tilePos.z).add(direction))) {
-                    mobSlime.moveTo(this.tilePos.x + 0.5 + direction.getOffsetX(), this.tilePos.y + 0.5 + direction.getOffsetY(), this.tilePos.z + 0.5 + direction.getOffsetZ(), this.random.nextFloat() * 360F, 0.0F);
-                    mobSlime.fling(direction.getOffsetX() * 0.75, direction.getOffsetY() * 0.75, direction.getOffsetZ() * 0.75, 1);
+                    mobSlime.moveTo(this.tilePos.x + 0.5 + direction.offsetX(), this.tilePos.y + 0.5 + direction.offsetY(), this.tilePos.z + 0.5 + direction.offsetZ(), this.random.nextFloat() * 360F, 0.0F);
+                    mobSlime.fling(direction.offsetX() * 0.75, direction.offsetY() * 0.75, direction.offsetZ() * 0.75, 1);
                 } else {
                     mobSlime.moveTo(this.tilePos.x + (double)f, this.tilePos.y + 1D, this.tilePos.z + (double)f1, this.random.nextFloat() * 360F, 0.0F);
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java b/game/core/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
index 88391617f..f7a2ded33 100644
--- a/game/core/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
@@ -60,9 +60,9 @@ public class CarriedBlock implements ICarriable, ICarriedBlock {
         if (entity != null) {
             return entity.tryPlace(world, holder, blockX, blockY, blockZ, side, xPlaced, yPlaced);
         } else {
-            int x = blockX + side.getOffsetX();
-            int y = blockY + side.getOffsetY();
-            int z = blockZ + side.getOffsetZ();
+            int x = blockX + side.offsetX();
+            int y = blockY + side.offsetY();
+            int z = blockZ + side.offsetZ();
 
             Block<?> currentBlock = world.getBlock(x, y, z);
             if (currentBlock != null && !currentBlock.hasTag(BlockTags.PLACE_OVERWRITES)) return false;
